

#include "createManifest.h"
#include "md5.h"
#include <io.h>
#include <fstream>
#include <streambuf>  
using namespace std;

extern "C"
{
#include "cJSON.h"
}

struct filesStruct
{
	vector<char *> splitPath;
	//std::string path;
	std::string md5 = "";
};


createManifest::createManifest()
{
	std::ifstream manifest("../cjsonTest2/config.json");
	std::string str((std::istreambuf_iterator<char>(manifest)), std::istreambuf_iterator<char>());
	cJSON *json = cJSON_Parse(str.c_str())->child;
	
	for (cJSON *cj = json; cj != nullptr; cj = cj->next)
	{
		std::string tag = cj->string;
		if (tag == "assetsPath")
		{
			for (cJSON *searchPaths = cj->child; searchPaths != nullptr; searchPaths = searchPaths->next)
			{
				//printf(searchPaths->valuestring);
				_assetsPath.push_back(searchPaths->valuestring);
			}
		}
		else
		{
			_manifestInfo[tag] = cj->valuestring;
		}
		//_jsonInfo[tag] = cj->valuestring;
	}
}

createManifest::~createManifest()
{

}

void createManifest::create()
{
	for (int i = 0; i < _assetsPath.size(); i++)
	{
		this->getFileAll(_assetsPath.at(i));
	}

	this->md5File(_allFiles);
	this->buildManifest();
}

//ȡҪļ
void createManifest::getFileAll(std::string path)
{
	long   hFile = 0;

	struct _finddata_t fileinfo;
	string p;
	if ((hFile = _findfirst(p.assign(path).append("\\*").c_str(), &fileinfo)) != -1)
	{
		do
		{
			if ((fileinfo.attrib &  _A_SUBDIR))
			{
				if (strcmp(fileinfo.name, ".") != 0 && strcmp(fileinfo.name, "..") != 0)
				{
					getFileAll(p.assign(path).append("\\").append(fileinfo.name));
				}	
			}
			else
			{
				_allFiles.push_back(p.assign(path).append("\\").append(fileinfo.name));
			}
		} while (_findnext(hFile, &fileinfo) == 0);

		_findclose(hFile);
	}
}

//ļmd5
void createManifest::md5File(std::vector<std::string> allFile)
{
	MD5 md5;

	std::vector<filesStruct> tmpFile;

	for (int i = 0; i < allFile.size(); i++)
	{
		filesStruct add;
		char *tmp = (char *)allFile.at(i).c_str();

		md5.reset();
		md5.update(ifstream(allFile.at(i)));
		add.md5 = md5.toString();
		//add.path = tmp;
		char *p = strtok(tmp, "\\");
		while (p != NULL)
		{
			add.splitPath.push_back(p);
			p = strtok(NULL, "\\");
		}
		tmpFile.push_back(add);
	}

	//md5ʱʹõǾ·
	//Ҫȥ·ȡԴĿ¼
	for (int i = 0; i < tmpFile.size(); i++)
	{
		strFileInfo add;

		vector<char *> splitPath = tmpFile.at(i).splitPath;

		int startIdx = 0;
		for (int j = 0; j < splitPath.size(); j++)
		{
			std::string tag = splitPath.at(j);
			if (tag == "src" || tag == "res")
			{
				startIdx = j + 1;
				break;
			}
		}

		for (int j = startIdx; j < splitPath.size(); j++)
		{
			add.pathFile = add.pathFile + splitPath.at(j) + "/";
		}

		add.pathFile.pop_back();
		add.md5 = tmpFile.at(i).md5;

		_resultFile.push_back(add);

	}

}

//
void createManifest::buildManifest()
{
	cJSON *pJsonRoot = cJSON_CreateObject();

	cJSON_AddStringToObject(pJsonRoot, "packageUrl", _manifestInfo["packageUrl"].c_str());

	cJSON_AddStringToObject(pJsonRoot, "remoteManifestUrl", _manifestInfo["remoteManifestUrl"].c_str());

	cJSON_AddStringToObject(pJsonRoot, "remoteVersionUrl", _manifestInfo["remoteVersionUrl"].c_str());

	cJSON_AddStringToObject(pJsonRoot, "version", _manifestInfo["version"].c_str());

	cJSON_AddStringToObject(pJsonRoot, "engineVersion", _manifestInfo["engineVersion"].c_str());


	cJSON *assets = cJSON_CreateObject();
	cJSON_AddItemToObject(pJsonRoot, "assets", assets);

	for (int i = 0; i < _resultFile.size(); i++)
	{
		cJSON *res = cJSON_CreateObject();

		cJSON_AddStringToObject(res, "md5", _resultFile.at(i).md5.c_str());
		cJSON_AddItemToObject(assets, _resultFile.at(i).pathFile.c_str(), res);
	}

	cJSON *searchPaths = cJSON_CreateArray();
	cJSON_AddItemToObject(pJsonRoot, "searchPaths", searchPaths);

	char * p = cJSON_Print(pJsonRoot);
	cJSON_Delete(pJsonRoot);

	printf(p);
	printf("\n");

	char *path = (char *)_manifestInfo["outputPath"].c_str();
	ofstream fout(path);
	if (fout)
	{
		fout << p << endl;
		fout.close();
		printf("complete!!! \n");
	}

	free(p);

}